/*************************************************** */
/* Rule Set Based Access Control                     */
/* Author and (c) 1999-2005: Amon Ott <ao@rsbac.org> */
/* Generic lists - internal structures               */
/* Last modified: 21/Sep/2005                        */
/*************************************************** */

#ifndef __RSBAC_REPL_TYPES_H
#define __RSBAC_REPL_TYPES_H

#define RSBAC_LIST_REPL_NAME_LEN 32
#define RSBAC_LIST_REPL_CRYPTALGO_LEN 64
#define RSBAC_LIST_REPL_CRYPTKEY_LEN 256

typedef __u32 rsbac_list_repl_partner_number_t;

/* Is this partner active */
#define REPL_flag_active 1
/* Is this partner a master, so we accept lists from there */
#define REPL_flag_master 2
/* Is this partner a slave, so we replicate lists there */
#define REPL_flag_slave 4

struct rsbac_list_repl_partner_entry_t {
	char name[RSBAC_LIST_REPL_NAME_LEN];
	__u32 ip_addr;
	__u16 ip_port;
	char crypt_algo[RSBAC_LIST_REPL_CRYPTALGO_LEN];
	char crypt_key[RSBAC_LIST_REPL_CRYPTKEY_LEN];
	__u32 crypt_key_len;
	__u32 flags;
};

enum rsbac_list_repl_mod_t { REPL_name, REPL_ip_addr, REPL_ip_port,
	REPL_crypt_algo, REPL_crypt_key, REPL_crypt_key_len,
	REPL_flags, REPL_ttl, REPL_none
};

union rsbac_list_repl_mod_data_t {
	char string[RSBAC_LIST_REPL_CRYPTKEY_LEN];
	__u32 ip_addr;
	__u16 ip_port;
	__u32 crypt_key_len;
	__u32 flags;
	rsbac_time_t ttl;
};
#endif
